/*
 * dmx512_tester.c
 *
 * Created: 12.08.2016 21:35:12
 * Author : karpe
 */ 

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "pwm.h"


#define USART_BAUDRATE 250000
#define UBRR_VALUE (F_CPU/16/USART_BAUDRATE-1)


#define COUNT_CHANNELS 6

unsigned char data[COUNT_CHANNELS];
unsigned int DMX_Current_Channel = 0;
unsigned int DMX_Start_Channel = 0;
char DMX_Break = 0;



void USART_Init()
{
	// Set baud rate
	UBRRH = (uint8_t)(UBRR_VALUE>>8);
	UBRRL = (uint8_t)UBRR_VALUE;
	/* Set frame format: 8data, 2stop bit */
	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
	//enable reception
	UCSRB |= (1<<RXEN);
	//     
	UCSRB |= (1<<RXCIE);
}



ISR(USART_RXC_vect)
{
	unsigned char UART_Status = UCSRA;
	unsigned char UART_Data = UDR;
	//   (Frame error)
	if (UART_Status & (1<<FE)){
		DMX_Current_Channel = 0;
		DMX_Break = 1;
	} else if (DMX_Break == 1){
		int index = DMX_Current_Channel - DMX_Start_Channel - 1;
		if ((index >= 0) && (index < COUNT_CHANNELS)){
			data[index] = UART_Data;
		}
		DMX_Current_Channel++;
	}
}

int main(void)
{
	USART_Init();
	PWM_Init();
	
	for (int i = 0; i < COUNT_CHANNELS; i++) data[i] = 0;
	
	sei();
    /* Replace with your application code */
    while (1) 
    {
		PWM_Set(1, data[0]);
		PWM_Set(2, data[1]);
    }
}

